import gtk
from utils import *

class StatusIcon:
    def build_menu(self):
        menu = gtk.Menu()
        for item in (
            ('Tube status', self.tube_win_activate),
            #None, # separator
            ('Quit', cb_call(gtk.main_quit)),
        ):
            if item==None:
                menu.add(gtk.SeparatorMenuItem())
            else:
                text, callback = item
                mi = gtk.MenuItem(text)
                mi.connect("activate", callback)
                menu.add(mi)
        menu.show_all()
        return menu

    def __init__(self, app, tube_win_factory):
        icon_file = '/usr/share/icons/hicolor/scalable/apps/connectr.svg'
        self.icon = gtk.status_icon_new_from_file(icon_file)

        self.quitter = quitter()

        self.menu = self.build_menu()

        self.app = app

        self.tube_win = None
        self.tube_win_factory = tube_win_factory

        self.icon.connect("activate", self.activate)
        self.icon.connect("popup-menu", self.popup_menu)

    def activate(self, icon):
        self.app.activate(toggle=True)

    def tube_win_activate(self, icon):
        if self.tube_win is None or self.tube_win.quitter is None:
            self.tube_win = self.tube_win_factory()
        elif self.tube_win.window.has_toplevel_focus():
            self.tube_win.close()
            self.tube_win = None
        else:
            self.tube_win.window.present()

    def popup_menu(self, icon, button, activate_time):
        self.menu.popup(None, None, gtk.status_icon_position_menu,
                     button, activate_time, self.icon)


